export interface LinkPlain<Ref extends number> {
    id: Ref;
    type_id: Ref;
    from_id: Ref;
    to_id: Ref;
}
export interface LinkRelations<L> {
    typed: L[];
    type: L;
    in: L[];
    inByType: {
        [id: number]: L[];
    };
    out: L[];
    outByType: {
        [id: number]: L[];
    };
    from: L;
    to: L;
}
export interface Link<Ref extends number> extends LinkPlain<Ref>, LinkRelations<Link<Ref>> {
    [key: string]: any;
}
export interface LinksResult<Link> {
    links: Link[];
    types: {
        [id: number]: Link[];
    };
    byId: {
        [id: number]: Link;
    };
}
export interface MinilinksGeneratorOptions {
    id: 'id';
    type_id: 'type_id';
    type: 'type';
    typed: 'typed';
    from_id: 'from_id';
    from: 'from';
    out: 'out';
    to_id: 'to_id';
    to: 'to';
    in: 'in';
    inByType: 'inByType';
    outByType: 'outByType';
    handler?: (link: any, result: any) => any;
}
export declare const MinilinksGeneratorOptionsDefault: MinilinksGeneratorOptions;
export declare function Minilinks<MGO extends MinilinksGeneratorOptions>(options: MGO): <L extends Link<number>>(linksArray?: any[], memory?: any) => LinksResult<L>;
export declare const minilinks: <L extends Link<number>>(linksArray?: any[], memory?: any) => LinksResult<L>;
